function getWeather(zipcode) { // Gets weather data from a remote xml file
  var weatherRequest = new XMLHttpRequest();
  weatherRequest.open("GET", "http://www.ejse.com/WeatherService/Service.asmx/GetWeatherInfo?zipCode=" + zipcode, true);

  weatherRequest.onerror = function error() {
    alert("Error: weather server not found.");
    return null;
  }
 
  weatherRequest.onload = function parse() {
    var return_data = new Array();
    var return_data_needed = new Array("Location", "IconIndex", "Temprature", "FeelsLike", "Forecast", "Visibility", "Pressure", "DewPoint", "UVIndex", "Humidity", "Wind", "ReportedAt", "LastUpdated");

    for (var value in return_data_needed) {
       return_data[return_data_needed[value]] = weatherRequest.responseXML.getElementsByTagName(return_data_needed[value])[0].firstChild.nodeValue;
    }

    displayWeather(return_data);
  }

  weatherRequest.send(null);
};

function displayWeather(current_weather) {
  // gets reference to localized strings
  var stringbundle = document.getElementById("strings");

  document.getElementById("displayWeather-Icon").setAttribute("src", "chrome://weather/skin/icons/" + current_weather["IconIndex"] + ".png");
  document.getElementById("displayWeather-Icon").setAttribute("hidden", "false");

  document.getElementById("displayWeather-Temperature").setAttribute("value", current_weather["Temprature"]);
  document.getElementById("displayWeather-Temperature").setAttribute("hidden", "false");

  document.getElementById("displayWeather-Location").setAttribute("value", stringbundle.getFormattedString("location", [current_weather["Location"]]));
  document.getElementById("displayWeather-Location").setAttribute("hidden", "false"); 

  for (var value in current_weather) {
    if (document.getElementById("weatherMoreData-" + value) != null){
      document.getElementById("weatherMoreData-" + value).setAttribute("value", current_weather[value]);
    }
  }

  document.getElementById("weather-mailpane-splitter").setAttribute("state", "open");
}

function initiateWeather() {
  var weather_prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("weather.");

  if (weather_prefs.getPrefType("zipcode") == 0 || weather_prefs.getPrefType("refresh") == 0 || weather_prefs.getPrefType("interval") == 0) {
    setTimeout("window.openDialog('chrome://weather/content/weatherOptions.xul', 'weatherOptions', 'chrome')", 500);
    } else {
    var zipcode = weather_prefs.getCharPref("zipcode");
    var refresh = weather_prefs.getBoolPref("refresh")
    var interval = weather_prefs.getCharPref("interval")

    getWeather(zipcode);

    if(refresh){
      setTimeout("initiateWeather()", interval * 60 * 1000);
    }
  }
}

document.addEventListener("load", initiateWeather(), false);

